# HAM : 
# registers a user on the system
# creates an aggregator for the user
#   and subscribes the user to the feeds that are in his portlet
# if registration is successfull, message ""
#   otherwise return the error message

set user_id [ns_queryget user_id]
set email [ns_queryget email]
set fnames [ns_queryget fnames]
set lname [ns_queryget lname]
set password [ns_queryget password]
set passwordconfirm [ns_queryget passwordconfirm]
set screen_name [ns_queryget screen_name]

set message ""

array set creation_info [auth::create_user \
				-user_id $user_id \
				-verify_password_confirm \
				-username $screen_name \
				-email $email \
				-first_names $fnames \
				-last_name $lname \
				-screen_name $screen_name \
				-password $password \
				-password_confirm $passwordconfirm ]

switch $creation_info(creation_status) {
	ok {
		# if successful
		# remove id from user_session_id
		ad_set_client_property "mashup" "user_session_id" ""
		# mark this user regsistered = 1 in mashup_user
		db_dml "update_mashup_user" "update mashup_user set registered=1 where user_id=:user_id"
		# create an aggregator for the user
		set aggregator_id [mashup::newsfeed::userinit -user_id $user_id]
		# subscribe the user to the source_id's in mashup_feeds table
		db_foreach "subscribesources" "select source_id from mashup_feeds where user_id=:user_id" {
			news_aggregator::subscription::new -aggregator_id $aggregator_id -source_id $source_id
		}
		auth::issue_login -persistent -user_id $user_id
	}
	default {
		# get the error
		if { [llength $creation_info(element_messages)] == 0 } {
			set message $creation_info(creation_message)
		}		
	}
}